package ui

import (
	"context"
	"strconv"
	"time"

	def "git.pbiernat.dev/egommerce/api-entities/http"
	"git.pbiernat.dev/egommerce/pricing-service/internal/app/service"
)

func GetProductPrice(srv *service.PriceService, prodID int) (*def.ProductPriceResponse, error) {
	ctx := context.Background() // FIXME TODO
	key := "pricing__product_price__" + strconv.Itoa(prodID)
	res := &def.ProductPriceResponse{}

	if price, _ := srv.FetchFromCache(ctx, key, "float"); price != 0 {
		res.Price = price.(float64)
	} else {
		price, err := srv.FetchFromDB(ctx, prodID)
		if err != nil {
			return res, err
		}

		res.Price = price
		srv.SaveToCache(ctx, key, res.Price, 30*time.Second) // FIXME refactor as cache service sth
	}

	return res, nil
}

// CalculateProductPrice mock
func CalculateProductPrice(srv *service.PriceService, prodID int, price float64) (float64, error) {
	// customer := srv.GetCustomer(customerID)
	// customerPromo := srv.GetCustomerPromotions(customer)
	// customerDiscount := srv.GetCustomerDiscounts(customer)

	// product := srv.GetProduct(prodID)
	// productPromo := srv.GetProductPromotions(product)
	// productDiscount := srv.GetProductDiscounts(product)

	// srv.ApplyPromotions(product, customerPromo)
	// srv.ApplyPromotions(product, customerDiscount)
	// srv.ApplyPromotions(product, productPromo)
	// srv.ApplyPromotions(product, productDiscount)
	// finalPrice := product.GetPrice()

	return price, nil
}
